
# -*- encoding:utf-8 -*-
# 経理システム (仮)
# Copyright (C) 2007-2008 HORIKAWA Hisashi. All rights reserved.
#     http://www.nslabs.jp/bside/

# This program is provided under the terms of the Common Public License
# ("Agreement"). Any use, reproduction or distribution of this program
# constitutes recipient's acceptance of the Agreement.
# See the Agreement for more details.
# http://www.ibm.com/developerworks/opensource/library/os-beehive/os-cpl.html



# 添付ファイルの種別
class AttachKindsController < ApplicationController
  def index
    list
    render :action => 'list'
  end

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def list
    #@attach_kind_pages, @attach_kinds = paginate :attach_kinds, :per_page => 10
    @attach_kinds = AttachKind.paginate :page => params[:page], :per_page => 20
  end

  def show
    @attach_kind = AttachKind.find(params[:id])
  end

  def new
    @attach_kind = AttachKind.new
  end

  def create
    @attach_kind = AttachKind.new(params[:attach_kind])
    if @attach_kind.save
      flash[:notice] = 'AttachKind was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @attach_kind = AttachKind.find(params[:id])
  end

  def update
    @attach_kind = AttachKind.find(params[:id])
    if @attach_kind.update_attributes(params[:attach_kind])
      flash[:notice] = 'AttachKind was successfully updated.'
      redirect_to :action => 'show', :id => @attach_kind
    else
      render :action => 'edit'
    end
  end

  def destroy
    AttachKind.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
end
