
# -*- encoding:utf-8 -*-
# 経理システム (仮)
# Copyright (C) 2007-2008 HORIKAWA Hisashi. All rights reserved.
#     http://www.nslabs.jp/bside/

# This program is provided under the terms of the Common Public License
# ("Agreement"). Any use, reproduction or distribution of this program
# constitutes recipient's acceptance of the Agreement.
# See the Agreement for more details.
# http://www.ibm.com/developerworks/opensource/library/os-beehive/os-cpl.html




# 銀行支店
class BankBranchesController < ApplicationController
  def index
    list
    render :action => 'list'
  end

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def list
    #@bank_branch_pages, @bank_branches = paginate :bank_branches, :per_page => 10
    @bank_branches = BankBranch.paginate :page => params[:page], :per_page => 20
  end
  
  # 支店の詳細
  def show
    @branch = BankBranch.find params[:id]
  end

  def new
    @bank_branch = BankBranch.new
  end

  def create
    @bank_branch = BankBranch.new(params[:bank_branch])
    if @bank_branch.save
      flash[:notice] = 'BankBranch was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @bank_branch = BankBranch.find(params[:id])
  end

  def update
    @bank_branch = BankBranch.find(params[:id])
    if @bank_branch.update_attributes(params[:bank_branch])
      flash[:notice] = 'BankBranch was successfully updated.'
      redirect_to :action => 'show', :id => @bank_branch
    else
      render :action => 'edit'
    end
  end

  def destroy
    BankBranch.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
end
