
# -*- encoding:utf-8 -*-
# 経理システム (仮)
# Copyright (C) 2007-2008 HORIKAWA Hisashi. All rights reserved.
#     http://www.nslabs.jp/bside/

# This program is provided under the terms of the Common Public License
# ("Agreement"). Any use, reproduction or distribution of this program
# constitutes recipient's acceptance of the Agreement.
# See the Agreement for more details.
# http://www.ibm.com/developerworks/opensource/library/os-beehive/os-cpl.html




# カンパニー設定
class CompanySettingsController < ApplicationController
  before_filter :login_required
  
  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def index
    if (cs = CompanySetting.find(:first))
      redirect_to :action => 'show', :id => cs
    else
      redirect_to :action => 'new'
    end
  end

=begin
  def list
    #@company_setting_pages, @company_settings = paginate :company_settings, :per_page => 10
    @company_settings = CompanySetting.paginate :page => params[:page],
                                                :per_page => 20
  end
=end

  def show
    @company_setting = CompanySetting.find(params[:id])
  end

  def new
    @company_setting = CompanySetting.new
  end

  def create
    @company_setting = CompanySetting.new(params[:company_setting])
    if @company_setting.save
      flash[:notice] = 'CompanySetting was successfully created.'
      redirect_to :action => 'show', :id => @company_setting
    else
      render :action => 'new'
    end
  end

  def edit
    @company_setting = CompanySetting.find(params[:id])
  end

  def update
    @company_setting = CompanySetting.find(params[:id])
    image = params[:company_setting][:logo_image]
    params[:company_setting].delete(:logo_image)
    @company_setting.attributes = params[:company_setting]
    @company_setting.logo_image = image.read if !image.blank?
    
    if @company_setting.save
      flash[:notice] = 'CompanySetting was successfully updated.'
      redirect_to :action => 'show', :id => @company_setting
    else
      render :action => 'edit'
    end
  end
  
=begin
  def destroy
    CompanySetting.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
=end
  
  # 画像データ
  def logo_image
    r = CompanySetting.find params[:id]
    send_data r.logo_image, :type => "image/png"
  end
end
