

# 輸入申告 / 輸入許可通知書
class ImportDeclarationsController < ApplicationController
  before_filter :login_required

  # GET /import_declarations
  # GET /import_declarations.xml
  def index
    @import_declarations = ImportDeclaration.find(:all)

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @import_declarations }
    end
  end

  # GET /import_declarations/1
  # GET /import_declarations/1.xml
  def show
    @import_declaration = ImportDeclaration.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @import_declaration }
    end
  end

  # GET /import_declarations/new
  # GET /import_declarations/new.xml
  def new
    @import_declaration = ImportDeclaration.new

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @import_declaration }
    end
  end

  # GET /import_declarations/1/edit
  def edit
    @import_declaration = ImportDeclaration.find(params[:id])
  end

  # POST /import_declarations
  # POST /import_declarations.xml
  def create
    pa = params[:import_declaration]
    @import_declaration = ImportDeclaration.new pa
    @import_declaration.attributes = {
      :declaration_number => pa[:declaration_number].gsub(/[ \t]/, ''),
      :bl_number => pa[:bl_number].gsub(/[ \t]/, ''),
      :invoice_price => (pa[:invoice_price].to_f * (10 **
                     @import_declaration.invoice_currency.exponent) + 0.5).floor,
      :created_by => current_user,
    }

    respond_to do |format|
      if @import_declaration.save
        flash[:notice] = 'ImportDeclaration was successfully created.'
        format.html { redirect_to(@import_declaration) }
        format.xml  { render :xml => @import_declaration, :status => :created, :location => @import_declaration }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @import_declaration.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /import_declarations/1
  # PUT /import_declarations/1.xml
  def update
    @import_declaration = ImportDeclaration.find(params[:id])
    
    pa = params[:import_declaration]
    @import_declaration.attributes = pa
    @import_declaration.attributes = {
      :declaration_number => pa[:declaration_number].gsub(/[ \t]/, ''),
      :bl_number => pa[:bl_number].gsub(/[ \t]/, ''),
      :invoice_price => (pa[:invoice_price].to_f * (10 **
                     @import_declaration.invoice_currency.exponent) + 0.5).floor
    }

    respond_to do |format|
      if @import_declaration.save
        flash[:notice] = 'ImportDeclaration was successfully updated.'
        format.html { redirect_to(@import_declaration) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @import_declaration.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /import_declarations/1
  # DELETE /import_declarations/1.xml
  def destroy
    @import_declaration = ImportDeclaration.find(params[:id])
    @import_declaration.destroy

    respond_to do |format|
      format.html { redirect_to(import_declarations_url) }
      format.xml  { head :ok }
    end
  end
end
