
# -*- encoding:utf-8 -*-
# 経理システム (仮)
# Copyright (C) 2007-2008 HORIKAWA Hisashi. All rights reserved.
#     http://www.nslabs.jp/bside/

# This program is provided under the terms of the Common Public License
# ("Agreement"). Any use, reproduction or distribution of this program
# constitutes recipient's acceptance of the Agreement.
# See the Agreement for more details.
# http://www.ibm.com/developerworks/opensource/library/os-beehive/os-cpl.html




# 元帳の予算・実績区分
class KubunsController < ApplicationController
  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def index
    list
    render :action => 'list'
  end

  def list
    #@kubun_pages, @kubuns = paginate :kubuns, :per_page => 10
    @kubuns = Kubun.paginate :page => params[:page], :per_page => 20
  end

  def show
    @kubun = Kubun.find(params[:id])
  end

  def new
    @kubun = Kubun.new
  end

  def create
    @kubun = Kubun.new(params[:kubun])
    if @kubun.save
      flash[:notice] = 'Kubun was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @kubun = Kubun.find(params[:id])
  end

  def update
    @kubun = Kubun.find(params[:id])
    if @kubun.update_attributes(params[:kubun])
      flash[:notice] = 'Kubun was successfully updated.'
      redirect_to :action => 'show', :id => @kubun
    else
      render :action => 'edit'
    end
  end

  def destroy
    Kubun.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
end
