
# -*- encoding:utf-8 -*-
# 経理システム (仮)
# Copyright (C) 2007-2008 HORIKAWA Hisashi. All rights reserved.
#     http://www.nslabs.jp/bside/

# This program is provided under the terms of the Common Public License
# ("Agreement"). Any use, reproduction or distribution of this program
# constitutes recipient's acceptance of the Agreement.
# See the Agreement for more details.
# http://www.ibm.com/developerworks/opensource/library/os-beehive/os-cpl.html



class OurContactsController < ApplicationController
  # GET /our_contacts
  # GET /our_contacts.xml
  def index
    @our_contacts = OurContact.find(:all)

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @our_contacts }
    end
  end

  # GET /our_contacts/1
  # GET /our_contacts/1.xml
  def show
    @our_contact = OurContact.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @our_contact }
    end
  end

  # GET /our_contacts/new
  # GET /our_contacts/new.xml
  def new
    @our_contact = OurContact.new

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @our_contact }
    end
  end

  # GET /our_contacts/1/edit
  def edit
    @our_contact = OurContact.find(params[:id])
  end

  # POST /our_contacts
  # POST /our_contacts.xml
  def create
    @our_contact = OurContact.new(params[:our_contact])

    respond_to do |format|
      if @our_contact.save
        flash[:notice] = 'OurContact was successfully created.'
        format.html { redirect_to(@our_contact) }
        format.xml  { render :xml => @our_contact, :status => :created, :location => @our_contact }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @our_contact.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /our_contacts/1
  # PUT /our_contacts/1.xml
  def update
    @our_contact = OurContact.find(params[:id])

    respond_to do |format|
      if @our_contact.update_attributes(params[:our_contact])
        flash[:notice] = 'OurContact was successfully updated.'
        format.html { redirect_to(@our_contact) }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @our_contact.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /our_contacts/1
  # DELETE /our_contacts/1.xml
  def destroy
    @our_contact = OurContact.find(params[:id])
    @our_contact.destroy

    respond_to do |format|
      format.html { redirect_to(our_contacts_url) }
      format.xml  { head :ok }
    end
  end
end
