
# -*- encoding:utf-8 -*-
# 経理システム (仮)
# Copyright (C) 2007-2008 HORIKAWA Hisashi. All rights reserved.
#     http://www.nslabs.jp/bside/

# This program is provided under the terms of the Common Public License
# ("Agreement"). Any use, reproduction or distribution of this program
# constitutes recipient's acceptance of the Agreement.
# See the Agreement for more details.
# http://www.ibm.com/developerworks/opensource/library/os-beehive/os-cpl.html




# ActiveRecord::Baseでないクラスのインスタンスで、Validationsの機能を使う。
# http://wiki.rubyonrails.org/rails/pages/HowToUseValidationsWithoutExtendingActiveRecord
class ValidatingBase
  def save; end
  def save!; end
  def update_attribute; end
  def new_record?; end
  def self.human_attribute_name(arg) arg.to_s; end
  include ActiveRecord::Validations

  def [](key)
    instance_variable_get(key)
  end
  
  def initialize(attributes = nil)
    if attributes
      attributes.each {|key, value|
        send "#{key}=", value
      }
    end
  end
end
