
# -*- encoding:utf-8 -*-
# 経理システム (仮)
# Copyright (C) 2007-2008 HORIKAWA Hisashi. All rights reserved.
#     http://www.nslabs.jp/bside/

# This program is provided under the terms of the Common Public License
# ("Agreement"). Any use, reproduction or distribution of this program
# constitutes recipient's acceptance of the Agreement.
# See the Agreement for more details.
# http://www.ibm.com/developerworks/opensource/library/os-beehive/os-cpl.html





# 計画 (予算)
class WorkActionsController < ApplicationController
  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def index
    list
    render :action => 'list'
  end

  def list
    @work_actions = WorkAction.paginate :page => params[:page], :per_page => 20
  end

  # 横に長く表示
  def show
    @work_action = WorkAction.find params[:id]
    @amounts = GeneralLedger.find :all,
                         :conditions => ['work_action_id = ?', @work_action.id],
                         :order => 'date'
  end

  def new
    @work_action = WorkAction.new
  end

  def create
    @work_action = WorkAction.new(params[:work_action])
    if @work_action.save
      flash[:notice] = 'WorkAction was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @work_action = WorkAction.find(params[:id])
  end

  def update
    @work_action = WorkAction.find(params[:id])
    if @work_action.update_attributes(params[:work_action])
      flash[:notice] = 'WorkAction was successfully updated.'
      redirect_to :action => 'show', :id => @work_action
    else
      render :action => 'edit'
    end
  end

  def destroy
    WorkAction.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
end
