
# 会計部門
class Division < ActiveRecord::Base
  has_many :controllers_divisions
  has_many :control_divisions, :through => :controllers_divisions
  belongs_to :role
  
  before_save :normalize_string
  
  def normalize_string
    self.name = normalize_kc(name)
    self.kana_name = normalize_kc(kana_name)
  end
  
  # 購買請求書・販売請求書共通
  def self.addable()
    find :all,
         :conditions => '(end_day IS NULL) AND purchase_active <> 0',
         :order => 'division_code'
  end
 
  def name2
    return "#{division_code} #{name}"
  end

  # 「所属」の視点でのコストセンタ
  def default_controller
    default_root = CompanySetting.find(:first).default_cost_center
    control_divisions.each {|cost_center|
      return cost_center if default_root.id == cost_center.root().id
    }
    raise # DEBUG
  end
  
  # 
  def controller(root_controller)
    raise if !root_controller
    ControlDivision.find :first,
                 :select => 'control_divisions.*',
                 :joins => 'JOIN controllers_divisions ON
                     control_divisions.id = controllers_divisions.control_division_id',
                 :conditions => ['division_id = ? AND parent_id = ?',
                                 attributes['id'], root_controller.id]
  end
end
