
# 輸入申告 / 輸入許可通知書
class ImportDeclaration < ActiveRecord::Base
  belongs_to 'invoice_currency', :class_name => 'Currency'
  belongs_to :created_by, :foreign_key => 'created_by', :class_name => 'User'
  
  has_many :imports_invoices
  has_many :invoices, :through => :imports_invoices

  before_save :normalize_string
  
  Incoterms = {   # TODO: マスタを作るか？
    # 1 => "EXW",
    # 2 => FCA
    # 3 => FAS
    4 => "FOB",
    # 5 => CFR
    6 => "CIF",
    # 7 => CPT
    # 8 => CIP
    # 9 => DAF
    # 10 => DES
    # 11 => DEQ
    # 12 => DDU
    # 13 => DDP
  }

  def normalize_string
    %w(exporter_name description).each {|attr|
      self[attr] = normalize self[attr]
    }
  end
end


def format_import_declaration_number s
  str = s.to_s
  s ? sprintf("%s %s %s", str[0..2], str[3..6], str[7..-1]) : nil
end

def format_bl_number s
  str = s.to_s
  s ? sprintf("%s %s", str[0..2], str[3..-1]) : nil
end
