class InvoiceDetail < ActiveRecord::Base
  belongs_to :invoice
  belongs_to :account_title
  belongs_to :division

  VAT_NAMES = {0 => "(科目に従う)", 10 => "税込5%", 30 => "非課税", 40 => "―"}
  
  before_save :normalize_string
  
  def normalize_string
    self.remarks = normalize_kc remarks
  end
  
  # @override
  def validate
    errors.add "vat_code", "は0以外でなければなりません。" if vat_code == 0
  end
  
  def self.vat_ary
    a = VAT_NAMES.to_a.sort {|x, y| x[0] <=> y[0]}
    a.collect {|k, v| [v, k]}
  end
end
