# 取引先（仕入先）
class Partner < ActiveRecord::Base
  has_many :bank_accounts
  has_many :invoices
  has_many :sales_invoices
  has_many :attach_file_refs
  belongs_to :updated_by, :foreign_key => 'updated_by', :class_name => 'User'
  # has_many :attach_files, :through => :attach_file_refs
  
  validates_presence_of :name
  validates_presence_of :kana_name
  validates_uniqueness_of :zaimu_id

  before_save :normalize_string
  
  def normalize_string
    self.name = normalize_kc name
    self.kana_name = normalize_kc(kana_name).gsub(/[ 　・]/, '')
    self.remarks = normalize_kc remarks
  end
  
  # ファイルの中身を取得しない
  def attach_files
    AttachFile.find :all,
           :select => 'a.id, a.original_filename, a.content_type, a.attach_kind_id, a.remarks, a.division_id, a.created_by, a.created_at',
           :from => 'attach_files AS a',
           :joins => 'JOIN attach_file_refs ON a.id = attach_file_refs.attach_file_id',
           :conditions => ['attach_file_refs.partner_id = ?', self['id']]
  end
end
