
-- 輸入申告
-- http://ec.europa.eu/agriculture/markets/export_refunds/forms/jp.pdf
-- http://help.sap.com/erp2005_ehp_03/helpdata/EN/2b/274550995111d1b4e30000e82d81b0/frameset.htm
CREATE TABLE import_declarations (
  id                  serial PRIMARY KEY,
  declaration_number  NUMERIC(11) NOT NULL UNIQUE,   -- 申告番号 N11
  exporter_name       VARCHAR(100) NOT NULL, -- 輸出者名
  bl_number           NUMERIC(12) NOT NULL UNIQUE,   -- AWB (B/L) 番号

  invoice_price       int NOT NULL,          -- 仕入書価格
  invoice_currency_id int NOT NULL REFERENCES currencies(id), -- invoiceの通貨
  invoice_incoterm_id int NOT NULL, 

  customs_tariff      int NOT NULL,          -- 関税
  consumption_tax     int NOT NULL,          -- 消費税
  description         TEXT NOT NULL,      -- 内容など
  permit_date         DATE NOT NULL,      -- 輸入許可日

  created_at          TIMESTAMP NOT NULL,
  created_by          int NOT NULL REFERENCES users (id),
  updated_at          TIMESTAMP
);
