-- サプライヤーからの請求書
CREATE TABLE invoices (
  id              serial PRIMARY KEY,
  partner_id      int NOT NULL REFERENCES partners(id),
    -- 銀行口座は会社分割等で紐付けを変更することがあり、取引先を優先する
  bank_account_id int REFERENCES bank_accounts(id),   -- 銀行口座がない相手もある
  buy_day         DATE NOT NULL,
  due_day         DATE NOT NULL,
  invoice_no      VARCHAR(20), 
  currency_id     int NOT NULL REFERENCES currencies(id),  -- 通貨
  division_id     int NOT NULL REFERENCES divisions(id),   -- 所管部門
  created_by      int NOT NULL REFERENCES users(id),
  journal_day     DATE,    -- 会計伝票日

  state           int NOT NULL,  -- 0 = 初期状態, 10 = 経理承認、20 = 会計システム連動済
  payment_state   int NOT NULL,  -- 0 = 初期状態, 10 = 支払依頼作成済み, 20 = キャンセル

  created_at      TIMESTAMP NOT NULL,
  updated_at      TIMESTAMP,
  lock_version    int NOT NULL,

  UNIQUE(partner_id, invoice_no)
);
