-- -*- encoding:utf-8 -*-
-- 顧客に対する請求書 B2B前提
CREATE TABLE sales_invoices (
  id           serial PRIMARY KEY,
  partner_id   int NOT NULL REFERENCES partners (id),
  si_number    int, -- 請求書番号

  -- 宛先... lightに、つど記入する
  zip           VARCHAR(10) NOT NULL,
  addr1         VARCHAR(100) NOT NULL,
  addr2         VARCHAR(100) NOT NULL,
  contact_name1 VARCHAR(100) NOT NULL,
  contact_name2 VARCHAR(100) NOT NULL,

  sell_day     DATE NOT NULL, 
  due_day      DATE NOT NULL,
  currency_id  int NOT NULL REFERENCES currencies (id),
  division_id  int NOT NULL REFERENCES divisions (id), -- 所管部門
  journal_day  DATE,            -- 会計伝票日
  state        int NOT NULL,    -- 0 = 初期状態, 10 = 経理承認, 20 = 会計システム連動
  remarks      TEXT NOT NULL,
  delivery     int NOT NULL,  -- 送付方法。1 = 担当者持参、2 = 郵送

  created_at   TIMESTAMP NOT NULL,
  created_by   int NOT NULL REFERENCES users (id),
  updated_at   TIMESTAMP,
  lock_version int NOT NULL
);
