
require 'csv'
require './import_common.rb'

establish_connection 'import_yosan.log'

require '../app/models/account_title'
require '../app/models/control_division'
require '../app/models/division'
require "../app/models/kubun"
require "../app/models/general_ledger"
require "../app/models/work_action"
require "../app/models/user"


def import_yosan2007
  GeneralLedger.transaction {
    ['yosan2007.csv', 'yosan2007-shokeihi.csv'].each {|filename|
      data = sjis2utf8(File.read(filename))
      
      kubun = Kubun.find(:first, :conditions => ["name = ?", "estimate"])
      raise if !kubun

      idx = 0
      days = []
      CSV::Reader.parse(data) {|line|
        idx += 1
        if idx == 1
          days = (0..11).collect {|i| line[7 + i]}
          next
        end

        if (line[2] && line[2] != "") && line[4].to_i != 0
          div =  find_division_by_code(line[2]) || raise("div = '#{line[2]}'")
          ac = find_account_title(line[4].to_i, line[5].to_i) || raise("ac = #{line[4]}")

          wa = WorkAction.new(:name => (line[0] || "") + (line[1] || ""))
          wa.save!

          (0..11).each {|i|
            gl = GeneralLedger.new(
                 :date => days[i],
                 :kubun => kubun,
                 :division => div,
                 :account_title => ac,
                 :work_action => wa,
                 :amount => (line[7 + i].to_f + 0.5).to_i * 1000,
                 :remarks => wa.name)
            gl.save!
          }
        end
      }
    }
  }
end

import_yosan2007()
