
# 最小限必要なレコードを作成する。

require File.dirname(__FILE__) + '/../config/environment'


# 通貨
def create_currencies
  list = [
    ['JPY', '円', 0],
    ['USD', 'US$', 2],
    ['EUR', 'EURO', 2]
  ]
  Currency.transaction {
    list.each {|data|
      cur = Currency.find_by_code(data[0]) ||
            Currency.new(:name => data[1],
                         :code => data[0],
                         :exponent => data[2])
      cur.name = data[1]
      cur.code = data[0]
      cur.exponent = data[2]
      cur.save!
    }
  }
end

# カンパニー
def create_company
  today = Date.today
  d = (Date.new(today.year, today.mon, 1) << 1) - 1 

  company = CompanySetting.new :name => '会社名 (変更してください)',
                          :name_en => 'Company Name (Please change)',
                          :fixed_day => d,
                          :fixed_gl_day => d,
                          :partner_counter => 1,
                          :si_counter => 1,
                          :si_footer => "www.yourdomain.com",
                          :currency_limit => d,
                          :functional_currency => Currency.find_by_code('JPY')
  company.save!
end

# 経理ロール
def create_accounting_role
  role = Role.new :name => '本社経理', :keiri => 1
  role.save! 
end


# 実績
def create_kubun_actual
  kubun = Kubun.new :name => 'actual', :long_name => '実績', :active => true
  kubun.save!
end

# ファイル種別
def create_attach_kinds
  list = [
    ["業態票", 5, 0],
    # ["振込口座登録票", 7, 0],
    ["取引基本契約", 10, 0],
    ["見積書", 20, 1],
    ["調達依頼書", 25, 1],
    ["稟議書", 27, 1],
    ["注文書 (控)", 30, 1],
    ["個別契約・注文請書", 40, 1],
    ["納品書", 50, 1],
    ["受領書 (控)", 60, 1],
    ["請求書", 70, 1],
    ["写真", 75, 1],
    ["その他", 99, 1],
  ]
  AttachKind.transaction {
    list.each {|line|
      r = AttachKind.new(:name => line[0], :sort => line[1],
                         :enable_invoice => line[2])
      r.save!
    }
  }
end


create_currencies
create_company
create_accounting_role
create_kubun_actual
create_attach_kinds
