require File.dirname(__FILE__) + '/../test_helper'
require 'attach_files_controller'

# Re-raise errors caught by the controller.
class AttachFilesController; def rescue_action(e) raise e end; end

class AttachFilesControllerTest < Test::Unit::TestCase
  fixtures :attach_files

  def setup
    @controller = AttachFilesController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new

    @first_id = attach_files(:first).id
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:attach_files)
  end

  def test_show
    get :show, :id => @first_id

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:attach_file)
    assert assigns(:attach_file).valid?
  end

  def test_new
    get :new

    assert_response :success
    assert_template 'new'

    assert_not_nil assigns(:attach_file)
  end

  def test_create
    num_attach_files = AttachFile.count

    post :create, :attach_file => {}

    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_attach_files + 1, AttachFile.count
  end

  def test_edit
    get :edit, :id => @first_id

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:attach_file)
    assert assigns(:attach_file).valid?
  end

  def test_update
    post :update, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => @first_id
  end

  def test_destroy
    assert_nothing_raised {
      AttachFile.find(@first_id)
    }

    post :destroy, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      AttachFile.find(@first_id)
    }
  end
end
