require File.dirname(__FILE__) + '/../test_helper'
require 'company_settings_controller'

# Re-raise errors caught by the controller.
class CompanySettingsController; def rescue_action(e) raise e end; end

class CompanySettingsControllerTest < Test::Unit::TestCase
  fixtures :company_settings

  def setup
    @controller = CompanySettingsController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new

    @first_id = company_settings(:first).id
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:company_settings)
  end

  def test_show
    get :show, :id => @first_id

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:company_setting)
    assert assigns(:company_setting).valid?
  end

  def test_new
    get :new

    assert_response :success
    assert_template 'new'

    assert_not_nil assigns(:company_setting)
  end

  def test_create
    num_company_settings = CompanySetting.count

    post :create, :company_setting => {}

    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_company_settings + 1, CompanySetting.count
  end

  def test_edit
    get :edit, :id => @first_id

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:company_setting)
    assert assigns(:company_setting).valid?
  end

  def test_update
    post :update, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => @first_id
  end

  def test_destroy
    assert_nothing_raised {
      CompanySetting.find(@first_id)
    }

    post :destroy, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      CompanySetting.find(@first_id)
    }
  end
end
