require File.dirname(__FILE__) + '/../test_helper'
require 'control_divisions_controller'

# Re-raise errors caught by the controller.
class ControlDivisionsController; def rescue_action(e) raise e end; end

class ControlDivisionsControllerTest < Test::Unit::TestCase
  fixtures :control_divisions

  def setup
    @controller = ControlDivisionsController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:control_divisions)
  end

  def test_show
    get :show, :id => 1

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:control_division)
    assert assigns(:control_division).valid?
  end

  def test_new
    get :new

    assert_response :success
    assert_template 'new'

    assert_not_nil assigns(:control_division)
  end

  def test_create
    num_control_divisions = ControlDivision.count

    post :create, :control_division => {}

    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_control_divisions + 1, ControlDivision.count
  end

  def test_edit
    get :edit, :id => 1

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:control_division)
    assert assigns(:control_division).valid?
  end

  def test_update
    post :update, :id => 1
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => 1
  end

  def test_destroy
    assert_not_nil ControlDivision.find(1)

    post :destroy, :id => 1
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      ControlDivision.find(1)
    }
  end
end
