require File.dirname(__FILE__) + '/../test_helper'
require 'invoice_details_controller'

# Re-raise errors caught by the controller.
class InvoiceDetailsController; def rescue_action(e) raise e end; end

class InvoiceDetailsControllerTest < Test::Unit::TestCase
  fixtures :invoice_details

  def setup
    @controller = InvoiceDetailsController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new

    @first_id = invoice_details(:first).id
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:invoice_details)
  end

  def test_show
    get :show, :id => @first_id

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:invoice_detail)
    assert assigns(:invoice_detail).valid?
  end

  def test_new
    get :new

    assert_response :success
    assert_template 'new'

    assert_not_nil assigns(:invoice_detail)
  end

  def test_create
    num_invoice_details = InvoiceDetail.count

    post :create, :invoice_detail => {}

    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_invoice_details + 1, InvoiceDetail.count
  end

  def test_edit
    get :edit, :id => @first_id

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:invoice_detail)
    assert assigns(:invoice_detail).valid?
  end

  def test_update
    post :update, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => @first_id
  end

  def test_destroy
    assert_nothing_raised {
      InvoiceDetail.find(@first_id)
    }

    post :destroy, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      InvoiceDetail.find(@first_id)
    }
  end
end
