require File.dirname(__FILE__) + '/../test_helper'
require 'kubuns_controller'

# Re-raise errors caught by the controller.
class KubunsController; def rescue_action(e) raise e end; end

class KubunsControllerTest < Test::Unit::TestCase
  fixtures :kubuns

  def setup
    @controller = KubunsController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:kubuns)
  end

  def test_show
    get :show, :id => 1

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:kubun)
    assert assigns(:kubun).valid?
  end

  def test_new
    get :new

    assert_response :success
    assert_template 'new'

    assert_not_nil assigns(:kubun)
  end

  def test_create
    num_kubuns = Kubun.count

    post :create, :kubun => {}

    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_kubuns + 1, Kubun.count
  end

  def test_edit
    get :edit, :id => 1

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:kubun)
    assert assigns(:kubun).valid?
  end

  def test_update
    post :update, :id => 1
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => 1
  end

  def test_destroy
    assert_not_nil Kubun.find(1)

    post :destroy, :id => 1
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      Kubun.find(1)
    }
  end
end
