require File.dirname(__FILE__) + '/../test_helper'
require 'our_banks_controller'

# Re-raise errors caught by the controller.
class OurBanksController; def rescue_action(e) raise e end; end

class OurBanksControllerTest < Test::Unit::TestCase
  fixtures :our_banks

  def setup
    @controller = OurBanksController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new

    @first_id = our_banks(:first).id
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:our_banks)
  end

  def test_show
    get :show, :id => @first_id

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:our_bank)
    assert assigns(:our_bank).valid?
  end

  def test_new
    get :new

    assert_response :success
    assert_template 'new'

    assert_not_nil assigns(:our_bank)
  end

  def test_create
    num_our_banks = OurBank.count

    post :create, :our_bank => {}

    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_our_banks + 1, OurBank.count
  end

  def test_edit
    get :edit, :id => @first_id

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:our_bank)
    assert assigns(:our_bank).valid?
  end

  def test_update
    post :update, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => @first_id
  end

  def test_destroy
    assert_nothing_raised {
      OurBank.find(@first_id)
    }

    post :destroy, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      OurBank.find(@first_id)
    }
  end
end
