require File.dirname(__FILE__) + '/../test_helper'
require 'partners_controller'

# Re-raise errors caught by the controller.
class PartnersController; def rescue_action(e) raise e end; end

class PartnersControllerTest < Test::Unit::TestCase
  fixtures :partners

  def setup
    @controller = PartnersController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new

    @first_id = partners(:first).id
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:partners)
  end

  def test_show
    get :show, :id => @first_id

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:partner)
    assert assigns(:partner).valid?
  end

  def test_new
    get :new

    assert_response :success
    assert_template 'new'

    assert_not_nil assigns(:partner)
  end

  def test_create
    num_partners = Partner.count

    post :create, :partner => {}

    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_partners + 1, Partner.count
  end

  def test_edit
    get :edit, :id => @first_id

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:partner)
    assert assigns(:partner).valid?
  end

  def test_update
    post :update, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => @first_id
  end

  def test_destroy
    assert_nothing_raised {
      Partner.find(@first_id)
    }

    post :destroy, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      Partner.find(@first_id)
    }
  end
end
