require File.dirname(__FILE__) + '/../test_helper'
require 'sales_invoices_controller'

# Re-raise errors caught by the controller.
class SalesInvoicesController; def rescue_action(e) raise e end; end

class SalesInvoicesControllerTest < Test::Unit::TestCase
  fixtures :sales_invoices

  def setup
    @controller = SalesInvoicesController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new

    @first_id = sales_invoices(:first).id
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:sales_invoices)
  end

  def test_show
    get :show, :id => @first_id

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:sales_invoice)
    assert assigns(:sales_invoice).valid?
  end

  def test_new
    get :new

    assert_response :success
    assert_template 'new'

    assert_not_nil assigns(:sales_invoice)
  end

  def test_create
    num_sales_invoices = SalesInvoice.count

    post :create, :sales_invoice => {}

    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_sales_invoices + 1, SalesInvoice.count
  end

  def test_edit
    get :edit, :id => @first_id

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:sales_invoice)
    assert assigns(:sales_invoice).valid?
  end

  def test_update
    post :update, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => @first_id
  end

  def test_destroy
    assert_nothing_raised {
      SalesInvoice.find(@first_id)
    }

    post :destroy, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      SalesInvoice.find(@first_id)
    }
  end
end
