require File.dirname(__FILE__) + '/../test_helper'
require 'work_actions_controller'

# Re-raise errors caught by the controller.
class WorkActionsController; def rescue_action(e) raise e end; end

class WorkActionsControllerTest < Test::Unit::TestCase
  fixtures :work_actions

  def setup
    @controller = WorkActionsController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:work_actions)
  end

  def test_show
    get :show, :id => 1

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:work_action)
    assert assigns(:work_action).valid?
  end

  def test_new
    get :new

    assert_response :success
    assert_template 'new'

    assert_not_nil assigns(:work_action)
  end

  def test_create
    num_work_actions = WorkAction.count

    post :create, :work_action => {}

    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_work_actions + 1, WorkAction.count
  end

  def test_edit
    get :edit, :id => 1

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:work_action)
    assert assigns(:work_action).valid?
  end

  def test_update
    post :update, :id => 1
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => 1
  end

  def test_destroy
    assert_not_nil WorkAction.find(1)

    post :destroy, :id => 1
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      WorkAction.find(1)
    }
  end
end
